/*
 * Compiz Tiles Plugin
 *
 * geometrysaverestore.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _TILES_GEOMETRYSAVERESTORE_H
#define _TILES_GEOMETRYSAVERESTORE_H

#include <core/windowgeometry.h>

class ResizableInterface;
class PointerFetchInterface;

class GeometryRelativeSaveRestoreInterface
{
    public:

	virtual ~GeometryRelativeSaveRestoreInterface () {}
	virtual compiz::window::Geometry restoreToRect () = 0;
	virtual void saveGeometry (const compiz::window::Geometry &r, unsigned int mask) = 0;
};

class PrivateGeometryRelativeSaveRestore;

class GeometryRelativeSaveRestore :
    public GeometryRelativeSaveRestoreInterface
{
    public:

	GeometryRelativeSaveRestore (ResizableInterface *resizable,
				     PointerFetchInterface *pointerFetch);
	~GeometryRelativeSaveRestore ();
	compiz::window::Geometry restoreToRect ();
	void saveGeometry (const compiz::window::Geometry &r, unsigned int mask);
    private:

	PrivateGeometryRelativeSaveRestore *priv;
};

#endif
