/*
 * Compiz Tiles Plugin
 *
 * resizeallocator.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _TILES_MAXIMIZATION_H
#define _TILES_MAXIMIZATION_H

#include <core/rect.h>

class ResizableInterface;

class MaximizableInterface
{
    public:

	virtual ~MaximizableInterface () {}

	virtual void maximize (unsigned int) = 0;
};

class MaximizationStateApplicationInterface
{
    public:

	virtual ~MaximizationStateApplicationInterface () {}

	virtual void applyMaximizeState (const CompRect &resizeTarget) = 0;
};

class PrivateMaximizationStateApplier;
class WindowMonitorInterface;

class MaximizationStateApplier :
    public MaximizationStateApplicationInterface
{
    public:

	MaximizationStateApplier (ResizableInterface *resizable,
				  WindowMonitorInterface *monitor,
				  MaximizableInterface *maximizable);

	void applyMaximizeState (const CompRect &resizeTarget);
    private:

	PrivateMaximizationStateApplier *priv;
};

#endif
