/*
 * Compiz Tiles Plugin
 *
 * mockresizable.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _TILES_MOCKANIMATEDRECT_H
#define _TILES_MOCKANIMATEDRECT_H

#include <core/rect.h>
#include <core/region.h>
#include "animatedrects.h"

class MockAnimatableRect :
    public AnimatableRectInterface
{
    public:

	MOCK_METHOD1 (setFromRectFunc, void (const boost::function <CompRect ()> &));
	MOCK_METHOD1 (setToRectFunc, void (const boost::function <CompRect ()> &));
	MOCK_METHOD1 (setDirection, bool (Type));
	MOCK_METHOD2 (progressAnimation, bool (int, bool));
	MOCK_METHOD1 (tweenedGeometry, CompRect (const CompRect &));
	MOCK_METHOD0 (getOpacity, unsigned int ());
};

#endif
