/*
 * Compiz Tiles Plugin
 *
 * mockresizable.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _TILES_MOCKDND_H
#define _TILES_MOCKDND_H

#include <core/rect.h>
#include <core/region.h>
#include "dnd.h"

class MockDroppable :
    public DroppableInterface
{
    public:

	MOCK_METHOD0 (dropGeometry, const CompRect & ());
	MOCK_METHOD1 (setPotentialDropZone, void (const CompRect &));
};

class MockDraggable :
    public DraggableInterface
{
    public:

	MOCK_METHOD1 (applyDrag, void (const CompPoint &));
	MOCK_METHOD0 (grab, void ());
	MOCK_METHOD0 (ungrab, void ());
};

class MockSnapRemovable :
    public SnapRemovableInterface
{
    public:

	MOCK_METHOD0 (shouldSnapOut, bool ());
	MOCK_METHOD1 (setGetSnapGeometryFunc, void (const GetGeometryFunc &func));
};

class MockDropCommit :
    public DropCommitInterface
{
    public:

	MOCK_METHOD0 (dropCommit, void ());
};

class MockDragAndDrop :
    public DragAndDropInterface
{
    public:

	MOCK_METHOD0 (dropGeometry, const CompRect & ());
	MOCK_METHOD1 (setPotentialDropZone, void (const CompRect &));
	MOCK_METHOD1 (applyDrag, void (const CompPoint &));
	MOCK_METHOD0 (grab, void ());
	MOCK_METHOD0 (ungrab, void ());
	MOCK_METHOD0 (shouldSnapOut, bool ());
	MOCK_METHOD1 (setGetSnapGeometryFunc, void (const GetGeometryFunc &func));
};

#endif
