/*
 * Compiz Tiles Plugin
 *
 * mockresizable.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _TILES_MOCKFBMANAGER_H
#define _TILES_MOCKFBMANAGER_H

#include <core/rect.h>
#include "fbmanager.h"

class MockFramebufferUpdate :
    public FramebufferUpdateInterface
{
    public:

	MOCK_METHOD0 (fboUpdate, bool ());
};

class MockFramebufferUpdateQueue :
    public FramebufferUpdateQueueInterface
{
    public:

	MOCK_METHOD1 (addQueuedUpdate, bool (FramebufferUpdateInterface *));
	MOCK_METHOD1 (removeUpdatesFromQueue, void (FramebufferUpdateInterface *));
};

class MockFramebufferQueuedUpdate :
    public FramebufferQueuedUpdateInterface
{
    public:

	MOCK_METHOD1 (setFramebufferHolder, void (FramebufferUpdateQueueInterface *));
	MOCK_METHOD0 (queueUpdate, void ());
};

class MockBackingFramebuffer :
    public BackingFramebufferInterface
{
    public:

	MOCK_CONST_METHOD0 (size, const CompSize & ());
	MOCK_CONST_METHOD0 (texture, GLuint ());
	MOCK_METHOD1 (bind, RebindableBackingFramebufferInterface::Ptr (const CompRect &));
	MOCK_METHOD1 (unbind, void (const RebindableBackingFramebufferInterface::Ptr &));
	MOCK_METHOD3 (drawAtPosition, bool (FramebufferDrawVertexData *,
					    GLMatrix *,
					    const CompRect &));
	MOCK_METHOD1 (setWeights, void (const std::vector <float> &));
};

#endif
