/*
 * Compiz Tiles Plugin
 *
 * mockresizable.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _TILES_MOCKGRABTRACKER_H
#define _TILES_MOCKGRABTRACKER_H

#include <boost/shared_ptr.hpp>
#include <core/rect.h>
#include <core/region.h>
#include "grabtracker.h"

class MockGrabTracker :
    public GrabTrackingInterface
{
    public:

	MOCK_METHOD7 (addGrabbedWindow, bool (TileAssignableInterface *,
					      AnimatableWindowInterface *,
					      WindowMonitorInterface *,
					      DrawableWindowInterface *,
					      DropCommitInterface *,
					      const tile::impl::GetWorkAreaFunc &,
					      const CompPoint &));
	MOCK_METHOD1 (removeGrabbedWindow, void (DropCommitInterface *));
	MOCK_METHOD9 (dragGrabbedWindow, void (ResizableInterface *,
					       TileAssignableInterface *,
					       WindowMonitorInterface *,
					       DrawableWindowInterface *,
					       MaximizationStateApplicationInterface *,
						const boost::shared_ptr <AnimatableRectInterface> &animatable,
						const boost::shared_ptr <DragAndDropInterface> &dnd,
						const boost::shared_ptr <ResizeAllocationInterface> &resizeAllocator,
					       const CompPoint &));
};

#endif
