/*
 * Compiz Tiles Plugin
 *
 * mockresizable.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _TILES_MOCKRESIZABLE_H
#define _TILES_MOCKRESIZABLE_H

#include <core/rect.h>
#include "resizable.h"

class MockResizable :
    public ResizableInterface
{
    public:

       MOCK_METHOD0 (frameGeometry, CompRect ());
       MOCK_METHOD0 (windowGeometry, CompRect ());
       MOCK_METHOD1 (toFrameGeometry, CompRect (const CompRect &));
       MOCK_METHOD1 (toWindowGeometry, CompRect (const CompRect &));
       MOCK_METHOD0 (grabGeometry, CompRect ());
       MOCK_METHOD1 (resizeWindow, void (const CompRect &));
       MOCK_METHOD1 (applyResizeRules, void (bool));
};

#endif

