/*
 * Compiz Tiles Plugin
 *
 * mocktile.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _TILES_MOCKTILE_H
#define _TILES_MOCKTILE_H

#include <core/rect.h>
#include <core/region.h>
#include "tile.h"
#include "mockdnd.h"
#include "mockresizeallocator.h"
#include "animatedrects.h"

class ResizableInterface;
class TileLayerMiscInterface;
class TileAssignableInterface;

class MockTile :
    public TileInterface
{
    public:

	MOCK_METHOD1 (current, CompRect (const CompRect &));
	MOCK_METHOD0 (window, ResizableInterface * ());
	MOCK_METHOD0 (asssigned, TileAssignableInterface * ());
	MOCK_METHOD0 (lockTargetSize, bool ());
	MOCK_METHOD1 (resized, void (CompRect &));
	MOCK_METHOD2 (animate, bool (int, bool));
	MOCK_METHOD0 (damage, void ());
	MOCK_METHOD1 (associate, bool (TileLayerMiscInterface *));
	MOCK_METHOD0 (disassociate, void ());
	MOCK_METHOD0 (layer, TileLayerMiscInterface * ());
	MOCK_METHOD0 (opacity, unsigned int ());
	MOCK_METHOD1 (scale, GLVector (const CompRect &));
	MOCK_METHOD1 (translation, GLVector (const CompRect &));
	MOCK_METHOD0 (getDrawWindowGeometry, CompRect ());
	MOCK_METHOD0 (getGrabWindowGeometry, CompRect ());
	MOCK_METHOD0 (dropGeometry, const CompRect & ());
	MOCK_METHOD1 (setPotentialDropZone, void (const CompRect &));
	MOCK_METHOD1 (applyDrag, void (const CompPoint &));
	MOCK_METHOD0 (grab, void ());
	MOCK_METHOD0 (ungrab, void ());
	MOCK_METHOD0 (shouldSnapOut, bool ());
	MOCK_METHOD1 (setGetSnapGeometryFunc, void (const GetGeometryFunc &func));
	MOCK_METHOD0 (dropCommit, void ());
	MOCK_METHOD0 (allocation, const CompRect & ());
	MOCK_METHOD1 (setAllocation, bool (const CompRect &));
	MOCK_METHOD1 (tileableFitsAllocation, bool (ResizableInterface *));
	MOCK_METHOD0 (target, const CompRect & ());
	MOCK_METHOD1 (setTarget, void (const CompRect &));
	MOCK_METHOD0 (assigned, TileAssignableInterface * ());
	MOCK_METHOD2 (allocateWindow, bool (ResizableInterface *, TileAssignableInterface *));
	MOCK_METHOD1 (setAnimation, bool (const AnimatableRectInterface::Type &));
	MOCK_METHOD0 (getGrabGeometry, CompRect ());
};

#endif
