/*
 * Compiz Tiles Plugin
 *
 * resizable.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _TILES_RESIZABLE_H
#define _TILES_RESIZABLE_H

#include <core/rect.h>

class ResizableInterface
{
    public:

    	virtual ~ResizableInterface () {}

    	virtual CompRect frameGeometry () = 0;
    	virtual CompRect windowGeometry () = 0;
	virtual CompRect toFrameGeometry (const CompRect &r) = 0;
	virtual CompRect toWindowGeometry (const CompRect &r) = 0;

	virtual CompRect grabGeometry () = 0;

	virtual void resizeWindow (const CompRect &r) = 0;
	virtual void applyResizeRules (bool lock) = 0;
};

#endif
