/*
 * Compiz Tiles Plugin
 *
 * tiles.cpp
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "resizeallocator.h"
#include "resizable.h"

class PrivateResizeAllocator
{
    public:

	CompRect mAllocation;
	ResizableInterface *mResizable;
};

ResizeAllocator::ResizeAllocator (ResizableInterface *resizable) :
    priv (new PrivateResizeAllocator ())
{
    priv->mResizable = resizable;
}

const CompRect &
ResizeAllocator::allocation ()
{
    return priv->mAllocation;
}

bool
ResizeAllocator::setAllocation (const CompRect &r)
{
    if (!tileableFitsAllocation (priv->mResizable))
	return false;

    priv->mAllocation = r;
    return true;
}

bool
ResizeAllocator::tileableFitsAllocation (ResizableInterface *tileable)
{
    return true;
}
