/*
 * Compiz Tiles Plugin
 *
 * tiles-test-utils.h
 *
 * Copyright (c) 2011 Sam Spilsbury <smspillaz@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <gtest/gtest.h>
#include <gmock/gmock.h>
#include <iostream>
#include <core/rect.h>
#include <core/region.h>
#include <core/point.h>

void PrintTo (const CompRect &r, std::ostream *os)
{
    *os << "CompRect: x: " << r.x () << " y: " << r.y () << " width: " << r.width () << " height: " << r.height () << std::endl;;
}

void PrintTo (const CompRegion &r, std::ostream *os)
{
    *os << "CompRegion: "
	<< std::endl
	<< " BoundingRect: "
	<< ::testing::PrintToString (r.boundingRect ())
	<< std::endl;

    for (const CompRect &rect : r.rects ())
	*os << "		Rectangle : "
	    << ::testing::PrintToString (rect)
	    << std::endl;
}

void PrintTo (const CompPoint &r, std::ostream *os)
{
    *os << "CompPoint: x: " << r.x () << " y: " << r.y () << std::endl;
}
